--
-- DoorOpener
--
-- written by fruktor, visit: www.eifok-team.de
-- Edit by }I{EKA special for MTZ-1025

DoorOpener = {};

DoorOpener.modDir = g_currentModDirectory;

function DoorOpener.prerequisitesPresent(specializations)
    return true; 
end;

function DoorOpener:load(savegame)
--  left door
	self.playerCallbackLeftDoor = SpecializationUtil.callSpecializationsFunction("playerCallbackLeftDoor"); 
	
	self.doorO = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.leftDoorOpener#trigger")) );
	if trigger == nil then
		print("[Error::LeftDoorOpener] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.leftDoorOpener#icIndex", i));
	
	self.doorO.icIndex = icIndex;
	self.doorO.trigger = trigger;
	self.doorO.plIR = false;
	
	addTrigger( trigger, "playerCallbackLeftDoor", self );
	
--  right door	
	self.playerCallbackRightDoor = SpecializationUtil.callSpecializationsFunction("playerCallbackRightDoor"); 
	
	self.door1 = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.RightDoorOpener#trigger")) );
	if trigger == nil then
		print("[Error::RightDoorOpener] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.rightDoorOpener#icIndex", i));
	
	self.door1.icIndex = icIndex;
	self.door1.trigger = trigger;
	self.door1.plIR = false;
		
	addTrigger( trigger, "playerCallbackRightDoor", self );

--  leftr door
	self.playerCallbackLeftrDoor = SpecializationUtil.callSpecializationsFunction("playerCallbackLeftrDoor"); 
	
	self.door3 = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.leftrDoorOpener#trigger")) );
	if trigger == nil then
		print("[Error::LeftrDoorOpener] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.leftrDoorOpener#icIndex", i));
	
	self.door3.icIndex = icIndex;
	self.door3.trigger = trigger;
	self.door3.plIR = false;
	
	addTrigger( trigger, "playerCallbackLeftrDoor", self );

--  leftr doorZ
	self.playerCallbackLeftrDoorZ = SpecializationUtil.callSpecializationsFunction("playerCallbackLeftrDoorZ"); 
	
	self.door4 = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.leftrDoorZOpener#trigger")) );
	if trigger == nil then
		print("[Error::LeftrDoorZOpener] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.leftrDoorZOpener#icIndex", i));
	
	self.door4.icIndex = icIndex;
	self.door4.trigger = trigger;
	self.door4.plIR = false;
	
	addTrigger( trigger, "playerCallbackLeftrDoorZ", self );

--  kapot
	self.playerCallbackKapot = SpecializationUtil.callSpecializationsFunction("playerCallbackKapot"); 
	
	self.door5 = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.KapotOpener#trigger")) );
	if trigger == nil then
		print("[Error::KapotOpener] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.kapotOpener#icIndex", i));
	
	self.door5.icIndex = icIndex;
	self.door5.trigger = trigger;
	self.door5.plIR = false;
		
	addTrigger( trigger, "playerCallbackKapot", self );

--  bagaj
	self.playerCallbackBagaj = SpecializationUtil.callSpecializationsFunction("playerCallbackBagaj"); 
	
	self.door6 = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.BagajOpener#trigger")) );
	if trigger == nil then
		print("[Error::BagajOpener] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.bagajOpener#icIndex", i));
	
	self.door6.icIndex = icIndex;
	self.door6.trigger = trigger;
	self.door6.plIR = false;
		
	addTrigger( trigger, "playerCallbackBagaj", self );
end;

function DoorOpener:delete()
-- left door
	if self.doorO.trigger ~= nil then
		removeTrigger(self.doorO.trigger);
	end;
--  right door
	if self.door1.trigger ~= nil then
		removeTrigger(self.door1.trigger);
	end;


-- leftr door
	if self.door3.trigger ~= nil then
		removeTrigger(self.door3.trigger);
	end;

-- leftr doorZ
	if self.door4.trigger ~= nil then
		removeTrigger(self.door4.trigger);
	end;

--  kapot
	if self.door5.trigger ~= nil then
		removeTrigger(self.door5.trigger);
	end;

--  bagaj
	if self.door6.trigger ~= nil then
		removeTrigger(self.door6.trigger);
	end;
end;

function DoorOpener:readStream(streamId, connection)
end;

function DoorOpener:writeStream(streamId, connection)
end;

function DoorOpener:mouseEvent(posX, posY, isDown, isUp, button)
end;

function DoorOpener:keyEvent(unicode, sym, modifier, isDown)
end;

function DoorOpener:update(dt)
	if self.doorO.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_LEFTDOOROPENER"), InputBinding.SET_DOOROPENER );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_LEFTDOOROPENER") );
		if InputBinding.hasEvent(InputBinding.SET_DOOROPENER)then
			local obj = self.interactiveObjects[self.doorO.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.doorO.icIndex);
			end;
		end
	end;
	if self.door1.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_RIGHTDOOROPENER"), InputBinding.SET_DOOROPENER );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_RIGHTDOOROPENER") );
		if InputBinding.hasEvent(InputBinding.SET_DOOROPENER)then
			local obj = self.interactiveObjects[self.door1.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.door1.icIndex);
			end;
		end
	end;



	if self.door3.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_LEFTRDOOROPENER"), InputBinding.SET_DOOROPENER );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_LEFTRDOOROPENER") );
		if InputBinding.hasEvent(InputBinding.SET_DOOROPENER)then
			local obj = self.interactiveObjects[self.door3.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.door3.icIndex);
			end;
		end
	end;

if self.door4.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_LEFTRDOORZOPENER"), InputBinding.SET_DOOROPENER );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_LEFTRDOORZOPENER") );
		if InputBinding.hasEvent(InputBinding.SET_DOOROPENER)then
			local obj = self.interactiveObjects[self.door4.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.door4.icIndex);
			end;
		end
	end;

if self.door5.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_KAPOTOPENER"), InputBinding.SET_DOOROPENER );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_KAPOTOPENER") );
		if InputBinding.hasEvent(InputBinding.SET_DOOROPENER)then
			local obj = self.interactiveObjects[self.door5.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.door5.icIndex);
			end;
		end
	end;

if self.door6.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_BAGAJOPENER"), InputBinding.SET_DOOROPENER );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_BAGAJOPENER") );
		if InputBinding.hasEvent(InputBinding.SET_DOOROPENER)then
			local obj = self.interactiveObjects[self.door6.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.door6.icIndex);
			end;
		end
	end;
end;

function DoorOpener:onLeave()
end;

function DoorOpener:draw()
end;

function DoorOpener:playerCallbackLeftDoor(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.doorO.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.doorO.plIR = false;
	end;
end;

function DoorOpener:playerCallbackRightDoor(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door1.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door1.plIR = false;
	end;
end;


function DoorOpener:playerCallbackLeftrDoor(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door3.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door3.plIR = false;
	end;
end;

function DoorOpener:playerCallbackLeftrDoorZ(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door4.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door4.plIR = false;
	end;
end;

function DoorOpener:playerCallbackKapot(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door5.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door5.plIR = false;
	end;
end;

function DoorOpener:playerCallbackBagaj(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door6.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door6.plIR = false;
	end;
end;